## Create Promo Code

### cURL

```
curl --request POST \
  --url https://api.withflex.com/v1/promo_codes \
  --header 'Authorization: Bearer <token>' \
  --header 'Content-Type: application/json' \
  --data '\n{\n  "promo_code": {\n    "coupon_id": "fcoup_1234567890",\n    "code": "SUMMER2016",\n    "max_redemptions": 100,\n    "customer": "fcus_01HACM7FZ1084XB1GB6053VM0D",\n    "metadata": {\n      "key": "value"\n    }\n  }\n}\n' 
```

### Python

```
import requests

url = "https://api.withflex.com/v1/promo_codes"

payload = { "promo_code": {
        "coupon_id": "fcoup_1234567890",
        "code": "SUMMER2016",
        "max_redemptions": 100,
        "customer": "fcus_01HACM7FZ1084XB1GB6053VM0D",
        "metadata": { "key": "value" }
    } }
headers = {
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.text)
```

### JavaScript

```
const options = {
  method: 'POST',
  headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
  body: JSON.stringify({
    promo_code: {
      coupon_id: 'fcoup_1234567890',
      code: 'SUMMER2016',
      max_redemptions: 100,
      customer: 'fcus_01HACM7FZ1084XB1GB6053VM0D',
      metadata: {key: 'value'}
    }
  })
};

fetch('https://api.withflex.com/v1/promo_codes', options)
  .then(res => res.json())
  .then(res => console.log(res))
  .catch(err => console.error(err));
```

### PHP

```
<?php

$curl = curl_init();

curl_setopt_array($curl, [\
  CURLOPT_URL => "https://api.withflex.com/v1/promo_codes",\
  CURLOPT_RETURNTRANSFER => true,\
  CURLOPT_ENCODING => "",\
  CURLOPT_MAXREDIRS => 10,\
  CURLOPT_TIMEOUT => 30,\
  CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,\
  CURLOPT_CUSTOMREQUEST => "POST",\
  CURLOPT_POSTFIELDS => json_encode([\
    'promo_code' => [\
        'coupon_id' => 'fcoup_1234567890',\
        'code' => 'SUMMER2016',\
        'max_redemptions' => 100,\
        'customer' => 'fcus_01HACM7FZ1084XB1GB6053VM0D',\
        'metadata' => [\
                'key' => 'value'\
        ]\
    ]\
  ]),\
  CURLOPT_HTTPHEADER => [\
    "Authorization: Bearer <token>",\
    "Content-Type: application/json"\
  ],\
]);

$response = curl_exec($curl);
$err = curl_error($curl);

curl_close($curl);

if ($err) {
  echo "cURL Error #:" . $err;
} else {
  echo $response;
}
?>
```

### Go

```
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

url := "https://api.withflex.com/v1/promo_codes"

payload := strings.NewReader("{\n  \"promo_code\": {\n    \"coupon_id\": \"fcoup_1234567890\",\n    \"code\": \"SUMMER2016\",\n    \"max_redemptions\": 100,\n    \"customer\": \"fcus_01HACM7FZ1084XB1GB6053VM0D\",\n    \"metadata\": {\n      \"key\": \"value\"\n    }\n  }\n}")

req, _ := http.NewRequest("POST", url, payload)

req.Header.Add("Authorization", "Bearer <token>")
	req.Header.Add("Content-Type", "application/json")

res, _ := http.DefaultClient.Do(req)

defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

fmt.Println(string(body))
}
```

### Responses

- `200`: Successful response with promotion code details.
  - **Example**:
  ```json
  {
    "promo_code": {
      "promo_code_id": "fpromo_01HACM7FZ1084XB1GB6053VM0E",
      "code": "SUMMER2016",
      "coupon": {
        "coupon_id": "fcoup_1234567890",
        "amount_off": 100,
        "applies_to": null,
        "duration": "once",
        "duration_in_months": null,
        "metadata": {
          "key": "value"
        },
        "name": "Coupon",
        "percent_off": 10,
        "max_redemptions": 100,
        "times_redeemed": 0,
        "valid": true,
        "created_at": "2024-05-17T14:59:21Z",
        "test_mode": true
      },
      "max_redemptions": 100,
      "times_redeemed": 0,
      "created_at": "2024-05-17T14:59:21Z",
      "customer": "fcus_01HACM7FZ1084XB1GB6053VM0D",
      "active": true,
      "metadata": {
        "key": "value"
      },
      "test_mode": false
    }
  }
  ```

- `401`: Unauthorized
- `403`: Forbidden
- `404`: Not Found
- `409`: Conflict
- `422`: Unprocessable Entity
- `429`: Too Many Requests

### Authorization
- Type: `Bearer Token`
- Description: Use a Bearer token to access this API.
